﻿/*
 * fbasync - An Asynchronous Facebook API for .NET
 * Copyright (C) 2007 ittybittysoft
 * Email: info@ittybittysoft.com
 * Portions of the library are based on the Facebook Developer Toolkit
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
using System.Collections.Generic;
using System.IO;
using System.Net;

namespace fbasync
{
    internal class ExtendedPermissionsState
        : FqlState
    {
        public IList<ExtendedPermissions> Results { get; set; }
    }

    internal class AlbumState
        : FqlState
    {
        public IList<Album> Results { get; set; }
    }

    internal class PhotoState
        : FqlState
    {
        public IList<Photo> Results { get; set; }
    }

    internal class UserState
        : FqlState
    {
        public IList<User> Results { get; set; }
    }

    internal class EventState
        : FqlState
    {
        public IList<Event> Results { get; set; }
    }

    internal class GroupState
        : FqlState
    {
        public IList<Group> Results { get; set; }
    }

    internal class LongListState
    {
        public IList<long> Results { get; set; }
    }

    internal class StoryTemplateBundleState
        : FqlState
    {
        public IList<StoryTemplateBundle> Results { get; set; }
    }

    internal class InfoSectionAsyncState
        : FqlState
    {
        public InfoSection Results { get; set; }
    }

    internal class InfoOptionsAsyncState
        : FqlState
    {
        public IList<InfoItem> Results { get; set; }
    }

    internal class Int32State
    {
        public int Result { get; set; }
    }

    internal class Int64State
    {
        public long Result { get; set; }
    }

    internal class BoolState
    {
        public bool Results { get; set; }
        public string TrueResult { get; set; }

        public BoolState()
            : this("1")
        {
        }

        public BoolState(string trueResult)
        {
            TrueResult = trueResult;
        }
    }

    internal class WebRequestAsyncState
    {
        public WebRequest Request;
        public Stream Result;
        public Stream ResponseStream;
        public byte[] ResponseBuffer;
        public Stream RequestStream;
        public byte[] RequestData;
    }

    internal abstract class FqlState
    {
        public bool KeepXml { get; set; }
    }
}
