﻿/*
 * fbasync - An Asynchronous Facebook API for .NET
 * Copyright (C) 2007 ittybittysoft
 * Email: info@ittybittysoft.com
 * Portions of the library are based on the Facebook Developer Toolkit
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using System.Security.Permissions;

namespace fbasync
{
    [DataContract, Serializable]
    public class ImageToken
    {
        [DataMember]
        public string src { get; set; }
        [DataMember]
        public string href { get; set; }
    }

    [DataContract, Serializable]
    public class FlashToken
    {
        [DataMember]
        public string swfsrc { get; set; }
        [DataMember]
        public string imgsrc { get; set; }
        [DataMember]
        public int? width { get; set; }
        [DataMember]
        public int? height { get; set; }
    }

    [DataContract, Serializable]
    public class Mp3Token
    {
        [DataMember]
        public string src { get; set; }
        [DataMember]
        public string title { get; set; }
        [DataMember]
        public string artist { get; set; }
        [DataMember]
        public string album { get; set; }
    }

    [DataContract, Serializable]
    public class VideoToken
    {
        [DataMember]
        public string video_src { get; set; }
        [DataMember]
        public string preview_img { get; set; }
        [DataMember]
        public string video_title { get; set; }
        [DataMember]
        public string video_link { get; set; }
        [DataMember]
        public string video_type { get; set; }
    }
}
