﻿/*
 * fbasync - An Asynchronous Facebook API for .NET
 * Copyright (C) 2007 ittybittysoft
 * Email: info@ittybittysoft.com
 * Portions of the library are based on the Facebook Developer Toolkit
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
using System.Runtime.Serialization;
using System.Xml;
using System;

namespace fbasync
{
    [DataContract(), Serializable()]
    public class Venue
    {
        public Venue()
        {
        }

        internal Venue(XmlElement venueEle)
        {
            if (null != venueEle)
            {
                street = venueEle.GetChildText("street");
                city = venueEle.GetChildText("city");
                state = venueEle.GetChildText("state");
                country = venueEle.GetChildText("country");
                latitude = venueEle.GetChildFloat("latitude");
                longitude = venueEle.GetChildFloat("longitude");
            }
        }

        [DataMember]
        public string street { get; set; }

        [DataMember]
        public string city { get; set; }

        [DataMember]
        public string state { get; set; }

        [DataMember]
        public string country { get; set; }

        [DataMember]
        public float? latitude { get; set; }

        [DataMember]
        public float? longitude { get; set; }
    }
}
